unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jpeg, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, StdCtrls, ExtCtrls, IdAntiFreezeBase, IdAntiFreeze, ImgList, ComCtrls,
  ShellApi;
function Pars(T_, ForS, _T: string): string;
type
  TForm1 = class(TForm)
    Image1: TImage;
    IdHTTP1: TIdHTTP;
    CaptchaEdit: TEdit;
    IdAntiFreeze1: TIdAntiFreeze;
    ListView1: TListView;
    ImageList1: TImageList;
    AccListView: TListView;
    GroupBox1: TGroupBox;
    Image2: TImage;
    Label1: TLabel;
    Label2: TLabel;
    GetCaptcha: TButton;
    RegButton: TButton;
    procedure GetCaptchaClick(Sender: TObject);
    procedure RegButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListView1CustomDrawItem(Sender: TCustomListView; Item: TListItem;
      State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure Image2Click(Sender: TObject);
    procedure Label1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  page:string;
  Names, Family:Tstringlist;
  MyItem: TListItem;
  AccountsFile:textfile;

implementation

{$R *.dfm}
function Pars(T_, ForS, _T: string): string;
var
  a, b: integer;
begin
  Result := '';
  if (T_ = '') or (ForS = '') or (_T = '') then
    Exit;
  a := Pos(T_, ForS);
  if a = 0 then
    Exit
  else
    a := a + Length(T_);
  ForS := Copy(ForS, a, Length(ForS) - a + 1);
  b := Pos(_T, ForS);
  if b > 0 then
    Result := Copy(ForS, 1, b - 1);
end;

function RandomName: string;
var
  thefirstname, thefirstname1: string;
const
  h_fnpre: array[0..122] of string =('te','ni','nila','andro','androma','sha','ara','ma','mana','la','landa','do','dori','pe','peri','conju','co','fo','fordre','da','dala','ke','kele','gra','grani','jo','sa','mala','ga','gavi','gavinra','mo','morlu','aga','agama','ba','balla','ballado','za','ari','ariu','au','auri','bra','ka','bu','buza','coi','bo','mu','muni','tho','thorga','ke','gri','bu','buri','hu','hugi','tho','thordi','ba','bandi','ga','bea','beaze','mo','modi','ma','malo','gholbi','gho','da','dagda','nua','nuada','oghma','ce','centri','cere','ce','ka','kathri','ado','adora','mora','mo','fe','felo','ana','anara','kera','mave','dela','mira','theta','tygra','adrie','diana','alsa','mari','shali','sira','sai','saithi','mala','kiri','ana','anaya','felha','drela','corda','nalme','na','um','ian','opi','lai','ygg','mne','ishn','kula','yuni');
  h_fnsuf: array[0..88] of string =('nn','las','math','th','ath','zar','ril','ris','rus','jurus','dred','rdred','lar','len','nis','rn','ge','lak','nrad','rad','lune','kus','mand','gamand','llador','dor','dar','nadar','rius','nius','zius','tius','sius','wield','helm','zan','tus','bor','nin','rgas','gas','lv','kelv','gelv','rim','sida','ginn','grinn','nn','huginn','rdin','ndis','bandis','gar','zel','di','ron','rne','lbine','gda','ghma','ntrius','dwyn','wyn','swyn','thris','dora','lore','nara','ra','las','gra','riel','lsa','rin','lis','this','lace','ri','naya','rana','lhala','lanim','rdana','lmeena','meena','fym','fyn','hara');
begin
result := '';
thefirstname := ''; thefirstname1 := '';
thefirstname := h_fnpre[Random(123)] + h_fnsuf[Random(89)];
thefirstname1 := copy(thefirstname, 1, 1);
thefirstname := thefirstname1 + Copy(thefirstname, 2, length(thefirstname) - 1);
result := thefirstname;
end;

function RandomPwd(PWLen: integer): string;
const StrTable: string =
'ABCDEFGHIJKLMabcdefghijklm' +
'0123456789' +
'NOPQRSTUVWXYZnopqrstuvwxyz';
var
 N, K, X, Y: integer;//    
begin
 if (PWlen > Length(StrTable)) then K := Length(StrTable)-1
 else K := PWLen;
 SetLength(result, K); //    
 Y := Length(StrTable); //     
 N := 0; //   
 while N < K do
  begin //    K 
   X := Random(Y) + 1; //    
   //       
   if (pos(StrTable[X], result) = 0) then
    begin
     inc(N); //   
     Result[N] := StrTable[X]; //   
    end;
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 Randomize;
 assignfile(AccountsFile, 'accounts.txt');
 Names:=Tstringlist.Create;
 Names.LoadFromFile('names.txt');
 Family:=Tstringlist.Create;
 Family.LoadFromFile('family.txt');
end;

procedure TForm1.GetCaptchaClick(Sender: TObject);
var
 MS:TMemoryStream;
 pic: TJPEGImage;
 captcha:string;
begin
 with idHTTP1.Request do
  begin
   UserAgent:='Opera/9.80 (Windows NT 6.0; U; ru) Presto/2.2.15 Version/10.10';
   Host:='odnoklassniki.ru';
   Accept:='text/html, application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-xbitmap, */*;q=0.1';
   AcceptLanguage:='ru-RU,ru;q=0.9,en;q=0.8';
   AcceptCharset:='iso-8859-1, utf-8, utf-16, *;q=0.1';
   ContentType:='application/x-www-form-urlencoded';
  end;
 MS:=TMemoryStream.Create;
 pic:= TJPEGImage.Create;
 try
  page:=idHTTP1.Get('http://odnoklassniki.ru/dk?st.cmd=anonymRegistrationEdit');
  captcha:=Pars('<img id="captcha" src="',page,'"');
  delete(captcha, Pos('&amp;',captcha)+1,4);
  idHTTP1.Get('http://odnoklassniki.ru'+captcha,MS);
  MS.Position:=0;
  pic.LoadFromStream(MS);
  Image1.Picture.Assign(pic);
  MyItem := ListView1.Items.Add;
  MyItem.Caption := ' ';
  MyItem.ImageIndex := 0;
  SendMessage(ListView1.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
  GetCaptcha.Enabled:=false;
  RegButton.Enabled:=true;
  CaptchaEdit.Enabled:=true;
  CaptchaEdit.SetFocus;
 except
  MyItem := ListView1.Items.Add;
  MyItem.Caption := '   ';
  MyItem.ImageIndex := 2;
  SendMessage(ListView1.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
 end;
 pic.Free;
 MS.Free;
end;

procedure TForm1.Image2Click(Sender: TObject);
begin
 ShellExecute(0, 'open', 'http://avtuh.ru/', nil, nil, SW_SHOW);
end;

procedure TForm1.Label1Click(Sender: TObject);
begin
  ShellExecute(0, 'open', 'http://grabberz.com/', nil, nil, SW_SHOW);
end;

procedure TForm1.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
const
  MyColors: array [0..2] of TColor = (clBlue, clGreen, clRed);
begin
  if Item = nil then
    Exit;//
  Sender.Canvas.Font.Color := MyColors[Item.ImageIndex];
end;

procedure TForm1.RegButtonClick(Sender: TObject);
var data:tstringlist;
    reg:boolean;
    login, pass, Hash:string;
    wnd: HWND;   TheChildHandle: HWND;
    cap: string;
begin
 data:=tstringlist.Create;
 data.Add('fr.posted=set');
 data.Add('fr.name='+Names[Random(Names.count)]);
 data.Add('fr.surname='+Family[Random(Family.count)]);
 data.Add('fr.gender='+inttostr(Random(2)+1));
 data.Add('fr.bday='+inttostr(Random(28)+1));
 data.Add('fr.bmonth='+inttostr(Random(12)+1));
 data.Add('fr.byear='+inttostr(Random(30)+1960));
 data.Add('fr.country=10414533690');
 data.Add('fr.city=');
 login:=RandomName+IntTostr(random(8000000)+1234567);
 data.Add('fr.lgn='+login);
 pass:=RandomPwd(10);
 data.Add('fr.rpassword='+pass);
 data.Add('fr.rpassword2='+pass);
 data.Add('fr.ccode='+CaptchaEdit.text);
 data.Add('button_register=');
 reg:=false;
 IdHTTP1.HandleRedirects:=false;
 try
  page:=IdHTTP1.Post('http://odnoklassniki.ru/dk?cmd=AnonymRegistrationEdit&st.cmd=anonymRegistrationEdit&tkn='+Pars('st.cmd=anonymRegistrationEdit&amp;tkn=',page,'"'),data);
 except
  if Pos('userGuideWizardGroup', IdHTTP1.Response.RawHeaders.text)<>0 then
   begin
    MyItem := ListView1.Items.Add;
    MyItem.Caption := ' ';
    MyItem.ImageIndex := 1;
    SendMessage(ListView1.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
    MyItem := AccListView.Items.Add;
    MyItem.Caption := login;
    MyItem.SubItems.Add(pass);
    SendMessage(AccListView.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
    append(AccountsFile);
    writeln(AccountsFile, login+';'+pass);
    closefile(AccountsFile);
    reg:=true;
   end;
 end;
  if reg then
   begin
    data.clear;
    data.Add('st.posted=set');
    data.Add('st.email='+login);
    data.Add('st.password='+pass);
    data.Add('st.fJS=enabled');
    data.Add('st.screenSize=1366 x 768');
    data.Add('st.flashVer=10.1.82');
    data.Add('button_go=');
    IdHTTP1.HandleRedirects:=true;
    try
     page:=IdHTTP1.Post('http://www.odnoklassniki.ru/dk?cmd=AnonymLogin&st.cmd=anonymLogin', data);
    except
    end;
    if Pos('LogoffUser', page)<>0 then
      begin
       Hash:=pars('gwtHash:"',page,'"');
       data.clear;
       IdHTTP1.Post('http://www.odnoklassniki.ru/dk?st.cmd=userGuideWizardEmail&st._aid=UserGuideWizard_Group_NextStep&gwt.requested='+Hash+'&gwt.previous=st.cmd%3DuserGuideWizardGroup',data);
       IdHTTP1.Post('http://www.odnoklassniki.ru/dk?st.cmd=userGuideWizardUserPhoto&st._aid=UserGuideWizard_Email_NextStep&gwt.requested='+Hash+'&gwt.previous=st.cmd%3DuserGuideWizardEmail%26st._aid%3DUserGuideWizard_Group_NextStep',data);
       IdHTTP1.Post('http://www.odnoklassniki.ru/dk?st.cmd=userGuideWizardActivation&st._aid=UserGuideWizard_UserPhoto_NextStep&gwt.requested='+Hash+'&gwt.previous=st.cmd%3DuserGuideWizardUserPhoto%26st._aid%3DUserGuideWizard_Email_NextStep',data);
       if Pos('LogoffUser', IdHTTP1.Post('http://www.odnoklassniki.ru/dk?st.cmd=userMain&st._aid=UserGuideWizard_Activation_NextStep&gwt.requested='+Hash+'&gwt.previous=st.cmd%3DuserGuideWizardActivation%26st._aid%3DUserGuideWizard_UserPhoto_NextStep',data))<>0 then
        begin
         MyItem := ListView1.Items.Add;
         MyItem.Caption := '';
         MyItem.ImageIndex := 1;
         SendMessage(ListView1.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
        end;
      end;
   end
  else
   begin
    MyItem := ListView1.Items.Add;
    MyItem.Caption := '  ';
    MyItem.ImageIndex := 2;
    SendMessage(ListView1.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
   end;
 data.Free;

 Image1.Picture:=nil;
 GetCaptcha.Enabled:=true;
 RegButton.Enabled:=false;
 CaptchaEdit.Text:='';
 CaptchaEdit.Enabled:=false;

 wnd := GetTopWindow(0);
  repeat
    SetLength(cap, GetWindowtextLength(wnd));
    GetWindowText(wnd, @cap[1], length(cap) + 1);
    if (trim(cap) = 'Odnoklassniki.ru Account Reger') then
     begin
      TheChildHandle := FindWindowEx(wnd, 0, nil, PChar(' '));
      SendMessage(TheChildHandle, WM_LButtonDown, 1, 1);
      SendMessage(TheChildHandle, WM_LButtonUP, 1, 1);
     end;
    wnd := GetNextWindow(wnd, GW_HWNDNEXT);
  until wnd = 0;

end;

end.
